;; -*- Mode: Scheme; tab-width: 4 -*-

;; tools for examining the environment

;; 0:
;;   0
;;   1
;;   2
;;   3
;; 1:
;;   0
;;   1
;; [...]

;; <env <next> <var0> <var1> ...>

(define (dump-env env)
  (let rib-loop ((depth 0)
		 (rib env))
    (when (not (%eq? rib *cte*))
	  (print depth ":")
	  (let val-loop ((i 1))
	    (if (< i (%tuple-length rib))
		(begin
		  ((stdout 'write-string) "    ")
		  (write* (%tuple-ref rib i) stdout)
		  (newline stdout)
		  (val-loop (+ i 1)))))
	  (if (tuple? env)
	      (rib-loop (+ depth 1) (%tuple-ref rib 0))))))


(define (insn-timer thunk)
  (let ((start (%insns)))
	(let ((result (thunk)))
	  (let ((finish (%insns)))
		(print (- finish start) "insns.")
		result))))