(initialize-runtime)
(initialize-stdio)
;; if you uncomment the next line be sure to uncomment the line
;; "test-runtime.scm" in the list of runtime sources in s48-bootstrap.scm.
;;(test-runtime)
((stdout 'write-string) "Lunacy.  Copyright 1998-2000 Sam Rushing")
(newline stdout)

(define (repl level in-port out-port)
  (let ((print (make-printer out-port))
	(old-error error))

    (set! error
	  (lambda args
	    (print args)
	    (repl (+ level 1) stdin stdout)))

    (define (prompt)
      (if (> level 0)
	  (write* level out-port))
      ((out-port 'write-string) "> ")
      ((out-port 'flush)))

    (prompt)

    (let loop ((exp (read in-port)))
      (if (not (eof-object? exp))
	  (let ((insns (%insns)))
	    (let ((closure (compile-to-closure exp (interaction-environment) #t)))
	      (let ((cinsns (%- (%insns) insns)))
		(let ((insns (%insns)))
		  (let ((result (closure)))
		    (let ((einsns (%- (%insns) insns)))
		      (if verbose-interaction
			  (print "; compile: " cinsns " execute: " einsns))
		      (write* result out-port)
		      (newline out-port)
		      ((out-port 'flush))
		      (set! _ result)
		      (prompt)
		      (loop (read in-port))))))))))
    (set! error old-error)
    ;; return the last value
    _
    ))

;; interact
(repl 0 stdin stdout)
