;; -*- Mode: Scheme; tab-width: 4 -*-

;; not finished.  eventually to replace %print, so we
;; can do output to raw descriptors.

(define (write* obj port)

  (let ((port-write-char (port 'write-char))
	(port-write-string (port 'write-string)))
    
    (define (write-string s)
      (let ((sl (string-length s)))
		(port-write-char #\")
		(let loop ((i 0))
		  (if (%lt? i sl)
			  (let ((ch (%string-ref s i)))
				(if (%eq? ch #\")
					(port-write-char #\\))
				(port-write-char ch)
				(loop (%+ i 1)))))
		(port-write-char #\")))

	(define (write-list l)
	  (port-write-char #\()
	  (let loop ((l l))
		(let ((first (%car l))
			  (rest (%cdr l)))
		  (write-object first)
		  (cond ((null? rest)
				 (port-write-char #\)))
				((pair? rest)
				 (port-write-char #\ )
				 (loop rest))
				(else
				 (port-write-string " . ")
				 (write-object rest)
				 (port-write-char #\)))))))

	(define (write-vector v)
	  (let ((vl (vector-length v)))
		(port-write-char #\#)
		(port-write-char #\()
		(let loop ((i 0))
		  (when (%lt? i vl)
				(write-object (vector-ref v i))
				(if (%lt? i (%- vl 1))
					(port-write-char #\ ))
				(loop (%+ i 1))))
		(port-write-char #\))))

	(define (write-number n)
	  (port-write-string (number->string n)))

	(define (write-object obj)
	  (cond ((char? obj)
			 (port-write-char #\#)
			 (port-write-char #\\)
			 (port-write-char obj))
			((boolean? obj)
			 (port-write-char #\#)
			 (if obj
				 (port-write-char #\t)
				 (port-write-char #\f)))
			((number? obj) (write-number obj))
			((null? obj) (port-write-string "()"))
			((undefined? obj) (port-write-string "#{undefined}"))
			((pair? obj) (write-list obj))
			((vector? obj) (write-vector obj))
			((string? obj) (write-string obj))
			((symbol? obj) (port-write-string (symbol->string obj)))
			(else
			 (port-write-char #\{)
			 (port-write-string
			  (case (%get-typecode obj)
				((#x0c) "closure ")
				((#x10) "save ")
				((#x1c) "tuple ")
				((#x28) "code ")
				(else "unknown-type ")))
			 (port-write-string (number->string (%- obj 0) #x10))
			 (port-write-char #\})
			 )
			))

	(write-object obj)
	))
